<template>
  <div class="card">
    <Circle v-if="!loaded" />
    <button
      v-if="loaded && large_network && !network_displayed"
      @click="displayNetwork()"
    >
      Netzwerk anzeigen
    </button>
    <div id="network_representation"></div>
  </div>
</template>

<script>
import { DataSet } from "vis-data/peer";
import { Network } from "vis-network/standalone";
import { Circle } from "vue-loading-spinner";

export default {
  name: "NetworkGraphVis",
  components: {
    Circle,
  },
  props: {
    network_data_json: JSON,
    selected_algorithm: String,
    loaded: Boolean,
  },
  data: function () {
    return {
      network_displayed: false,
      large_network: false,
    };
  },
  watch: {
    network_data_json: function () {
      this.network_displayed = false;
      const container = document.getElementById("network_representation");
      if (this.network_data_json != null) {
        if (this.network_data_json.info.nodes_count > 400) {
          this.large_network = true;
        } else {
          this.large_network = false;
        }
        if (!this.large_network) {
          this.createGraph(container);
        }
      } else if (this.network_data_json == null) {
        this.clearGraph(container);
      }
    },
    selected_algorithm: function () {
      if (this.selected_algorithm != "no-selection") {
        document.getElementById("network_representation").dispatchEvent(
          new Event("reset", {
            bubbles: true,
            cancelable: true,
            composed: false,
          })
        );
      }
    },
  },
  mounted: function () {
    console.log("Mounted NetworkGraphVis: ");
    console.log(this.network_data_json);
    if (this.network_data_json != null && !this.large_network) {
      const container = document.getElementById("network_representation");
      this.createGraph(container);
    }
  },
  methods: {
    displayNetwork: function () {
      var result_ok = confirm(
        "Dieses Netzwerk ist groß und daher wird es einige Sekunden dauern bis das Netzwerk angezeigt werden wird. Trotzdem anzeigen?"
      );
      if (result_ok) {
        const container = document.getElementById("network_representation");
        this.createGraph(container);
        this.network_displayed = true;
      }
    },
    clearGraph: function (htmlElementContainer) {
      var nodes = new DataSet([]);
      var edges = new DataSet([]);
      var data = {
        nodes: nodes,
        edges: edges,
      };
      new Network(htmlElementContainer, data, {});
    },
    createGraph: function (htmlElementContainer) {
      var nodes = new DataSet(this.network_data_json.nodes);
      var edges = new DataSet(this.network_data_json.links);
      var data = {
        nodes: nodes,
        edges: edges,
      };
      var options = {
        layout: {
          randomSeed: "0.4946896452321343:1642067553746",
          improvedLayout: false,
        },
        nodes: {
          borderWidthSelected: 3,
          font: {
            color: "#e8e8e8",
          },
          shape: "circle",
        },
        edges: {
          physics: false,
          width: 0.7,
          hoverWidth: 3,
          selectionWidth: 3,
          color: {
            inherit: false,
          },
        },
        interaction: {
          hover: true,
          multiselect: true,
        },
      };
      var network = new Network(htmlElementContainer, data, options);
      if (Object.entries(this.network_data_json["evaluation"]).length == 0) {
        this.handleClickOnOriginalGraphNeighbors(network, nodes);
      }
      return network;
    },
    handleClickOnOriginalGraphNeighbors: function (network, nodes) {
      const COLOR_NODES_DEFAULT = "#095c7e"; //blue
      const COLOR_BORDER_DEFAULT = "#08516f"; //dark blue
      const COLOR_NODE1_NEIGHBORS = "#CFB407"; //dark yellow
      const COLOR_NODE2_NEIGHBORS = "#740976"; //purple

      var changedNodesIds = [];
      var selectedNodeIds = [];
      var coloredNodesByHovering = [];

      const context = this;

      var highlightNode = function (
        node,
        allNodes,
        changedNodesIds,
        highlightColor,
        colorBorder
      ) {
        if (colorBorder) {
          allNodes.update({
            id: node,
            borderWidth: 3,
            color: {
              border: highlightColor,
            },
          });
        } else {
          allNodes.update({
            id: node,
            color: {
              background: highlightColor,
            },
          });
        }
        network.fit();
        changedNodesIds.push(node);
      };

      var highlightNodeNeighbours = function (
        network,
        nodeId,
        allNodes,
        changedNodesIds,
        highlightColor,
        colorBorder
      ) {
        var neighbors = [];
        neighbors = network.getConnectedNodes(nodeId);
        neighbors.forEach((neighbor) => {
          highlightNode(
            neighbor,
            allNodes,
            changedNodesIds,
            highlightColor,
            colorBorder
          );
        });

        var eventText =
          "Der Knoten <b>" +
          nodeId +
          "</b> hat <b>" +
          neighbors.length +
          "</b> Nachbarn:<br>" +
          neighbors +
          "<br><br>";
        context.$emit("node_selected", eventText);
      };

      var resetNodesColor = function (nodesToReset, allNodes) {
        nodesToReset.forEach((nodeId) => {
          allNodes.update({
            id: nodeId,
            borderWidth: 1,
            color: {
              background: COLOR_NODES_DEFAULT,
              border: COLOR_BORDER_DEFAULT,
            },
          });
        });
      };

      var resetNodesBackgroundColor = function (nodesToReset, allNodes) {
        nodesToReset.forEach((nodeId) => {
          allNodes.update({
            id: nodeId,
            color: {
              background: COLOR_NODES_DEFAULT,
            },
          });
        });
      };

      network.on("hoverNode", function (params) {
        var selectedNode = params.node;
        console.log(network.number_of_nodes)

        if (context.selected_algorithm == "aa" && nodes.length <= 100) {
          if (selectedNodeIds.length >= 2) {
            coloredNodesByHovering = network.getConnectedNodes(selectedNode);
            highlightNodeNeighbours(
              network,
              selectedNode,
              nodes,
              changedNodesIds,
              COLOR_NODE1_NEIGHBORS,
              false
            );
          }
        }
      });
      network.on("blurNode", function () {
        if (context.selected_algorithm == "aa" && nodes.length <= 100) {
          if (selectedNodeIds.length >= 2) {
            resetNodesBackgroundColor(
              coloredNodesByHovering,
              nodes
            );
            coloredNodesByHovering = [];
          }
        }
      });

      network.on("click", function (params) {
        if (params.event.type == "press") {
          if (
            context.selected_algorithm == "cn" ||
            context.selected_algorithm == "pa" ||
            context.selected_algorithm == "jc" ||
            context.selected_algorithm == "aa"
          ) {
            var selectedNodes = params.nodes;

            if (selectedNodes.length % 2 != 0 && selectedNodes.length != 0) {
              if (selectedNodes.length != 1) {
                context.$emit("nodes_unselected", "");
                network.unselectAll();
                resetNodesColor(changedNodesIds, nodes);
                network.selectNodes([selectedNodes[selectedNodes.length - 1]]);
                changedNodesIds = [];
                selectedNodeIds = [];
              }
              selectedNodeIds.push(selectedNodes[selectedNodes.length - 1]);
              if (
                context.selected_algorithm == "cn" ||
                context.selected_algorithm == "jc" ||
                context.selected_algorithm == "pa"
              ) {
                highlightNodeNeighbours(
                  network,
                  selectedNodes[selectedNodes.length - 1],
                  nodes,
                  changedNodesIds,
                  COLOR_NODE1_NEIGHBORS,
                  false
                );
              } else if (context.selected_algorithm == "aa") {
                //dont highlight neighbors, only highlight common neighbors

                var neighbors = network.getConnectedNodes(
                  selectedNodes[selectedNodes.length - 1]
                );
                neighbors.forEach((neighbor) => {
                  changedNodesIds.push(neighbor);
                });
              }
            } else if (selectedNodes.length % 2 == 0) {
              network.selectNodes(selectedNodes);
              selectedNodeIds.push(selectedNodes[selectedNodes.length - 1]);
              if (
                context.selected_algorithm == "cn" ||
                context.selected_algorithm == "jc" ||
                context.selected_algorithm == "pa"
              ) {
                highlightNodeNeighbours(
                  network,
                  selectedNodes[selectedNodes.length - 1],
                  nodes,
                  changedNodesIds,
                  COLOR_NODE2_NEIGHBORS,
                  true
                );
              } else if (context.selected_algorithm == "aa") {
                var neighborsAA = network.getConnectedNodes(
                  selectedNodes[selectedNodes.length - 1]
                );
                neighborsAA.forEach((neighbor) => {
                  changedNodesIds.push(neighbor);
                });
              }

              if (
                context.selected_algorithm == "cn" ||
                context.selected_algorithm == "jc" ||
                context.selected_algorithm == "aa"
              ) {
                // algorithm: common neighbors
                var allNeighbors = new Map();
                changedNodesIds.forEach((node) => {
                  var currentCount = allNeighbors.get(node);
                  if (typeof currentCount == "undefined") {
                    currentCount = 0;
                  }
                  allNeighbors.set(node, currentCount + 1);
                });

                var commonNeighbors = [];
                for (const [key, value] of allNeighbors.entries()) {
                  if (value > 1) {
                    commonNeighbors.push(key);
                  }
                }

                if (context.selected_algorithm == "cn") {
                  // algorithm: common neighbors
                  var eventTextCN =
                    "Die Knoten <b>" +
                    selectedNodes[0] +
                    "</b> und <b>" +
                    selectedNodes[1] +
                    "</b> haben <b>" +
                    commonNeighbors.length +
                    " gemeinsame Nachbarn</b>:<br>" +
                    commonNeighbors;
                  context.$emit("node_selected", eventTextCN);
                } else if (context.selected_algorithm == "jc") {
                  // algorithm: jaccard's coefficient
                  var allNeighborsCount = allNeighbors.size;
                  var commonNeighborsCount = commonNeighbors.length;

                  var eventTextJC =
                    "Die Knoten <b>" +
                    selectedNodes[0] +
                    "</b> und <b>" +
                    selectedNodes[1] +
                    "</b> haben <b>" +
                    commonNeighborsCount +
                    " gemeinsame Nachbarn</b> und <b>" +
                    allNeighborsCount +
                    " Nachbarn insgesamt</b>. <br><br>Damit haben sie einen <b>Jaccard's Coefficient</b> von <b>" +
                    (commonNeighborsCount / allNeighborsCount).toFixed(2) +
                    "</b>, da: " +
                    commonNeighborsCount +
                    " : " +
                    allNeighborsCount +
                    " = " +
                    (commonNeighborsCount / allNeighborsCount).toFixed(2);
                  context.$emit("node_selected", eventTextJC);
                } else if (context.selected_algorithm == "aa") {
                  // algorithm: adamic / adar

                  var neighborsOfCommonNeighbors = new Map();
                  commonNeighbors.forEach((commonNeighbor) => {
                    highlightNode(
                      commonNeighbor,
                      nodes,
                      changedNodesIds,
                      COLOR_NODE2_NEIGHBORS,
                      true
                    );

                    var neighborNeighborsCount =
                      network.getConnectedNodes(commonNeighbor).length;
                    neighborsOfCommonNeighbors.set(
                      commonNeighbor,
                      neighborNeighborsCount
                    );
                  });

                  var eventTextAA =
                    "Die Knoten <b>" +
                    selectedNodes[0] +
                    "</b> und <b>" +
                    selectedNodes[1] +
                    "</b> haben <b>" +
                    commonNeighbors.length +
                    " gemeinsame Nachbarn</b>:<br>" +
                    commonNeighbors +
                    "<br><br>Diese haben jeweils die folgende Anzahl an Nachbarn:<br>";

                  var adamicAdarScore = 0;
                  var values = [];
                  for (const [
                    key,
                    value,
                  ] of neighborsOfCommonNeighbors.entries()) {
                    eventTextAA += "Knoten " + key + ": " + value + "<br>";
                    adamicAdarScore += 1 / Math.log(value);
                    values.push(value);
                  }
                  adamicAdarScore = adamicAdarScore.toFixed(2);

                  eventTextAA +=
                    "<br>Damit ergibt sich ein <b>Adamic/Adar Score</b> von <b>" +
                    adamicAdarScore +
                    "</b>.<br><br>";

                  eventTextAA += "( ";
                  for (var i = 0; i < values.length; i++) {
                    eventTextAA += "1/log(" + values[i] + ") +";
                  }
                  eventTextAA = eventTextAA.slice(0, -1);
                  eventTextAA += ")";

                  context.$emit("node_selected", eventTextAA);
                }
                commonNeighbors = [];
              } else if (context.selected_algorithm == "pa") {
                // algorithm: preferential attachment
                var neighborsNode1 = network.getConnectedNodes(
                  selectedNodes[0]
                );
                var neighborsNode2 = network.getConnectedNodes(
                  selectedNodes[1]
                );
                var eventTextPA =
                  "Die Knoten <b>" +
                  selectedNodes[0] +
                  "</b> und <b>" +
                  selectedNodes[1] +
                  "</b> haben einen <b>Preferentail Attachment Score</b> von <b>" +
                  neighborsNode1.length * neighborsNode2.length +
                  "</b>, da:<br>" +
                  neighborsNode1.length +
                  " * " +
                  neighborsNode2.length +
                  " = " +
                  neighborsNode1.length * neighborsNode2.length;
                context.$emit("node_selected", eventTextPA);
              }
            }
          }
        } else if (params.event.type == "tap") {
          network.unselectAll();
          resetNodesColor(changedNodesIds, nodes);
          changedNodesIds = [];
          context.$emit("nodes_unselected", "");
        }
      });

      document
        .getElementById("network_representation")
        .addEventListener("reset", () => {
          network.unselectAll();
          resetNodesColor(changedNodesIds, nodes);
          changedNodesIds = [];
          context.$emit("nodes_unselected", "");
        });
    },
  },
};
</script>

<style scoped>
#network_representation {
  height: 700px;
  overflow: hidden;
  margin: 0px;
}

button {
  border: 1px solid cornflowerblue !important;
  border-radius: 4px;
  float: left;
}
</style>